import 'package:flutter_test/flutter_test.dart';

import 'package:djinn_flutter/djinn_flutter.dart';


class Counter extends DjinnService {
  var state = {
    'count': 0
  };

  increment() {
    patch({
      'count': state['count'] + 1
    });
  }

  decrement() {
    patch({
      'count': state['count'] - 1
    });
  }
}

void main() {
  test('register a service', () {
    Djinn().register(() => Counter());
    Djinn().init();

    final Counter service = Djinn().get();

    expect(service != null, true);
    expect(service.state['count'], 0);

    Djinn().remove<Counter>();
  });

  test('propagate changes', () {
    Djinn().register(() => Counter());
    Djinn().init();

    final Counter service = Djinn().get();
    service.increment();

    expect(service.state['count'], 1);

    Djinn().remove<Counter>();
  });
}
